unit AIOWDG;

interface

uses
  Windows;

type
  PLongBool = ^LongBool;
    
const //Watchdog function constants
  WDG_ACTION_IGNORE = 0;
  WDG_ACTION_DISABLE = 1;
  WDG_ACTION_SOFT_RESTART = 2;
  WDG_ACTION_MOSTLY_SOFT_RESTART = 4;

function GetNumCards: LongInt; cdecl; external 'AIOWDG.dll';
function GetCardBySerialNumber(const pSerialNumber: Int64): LongInt; cdecl; external 'AIOWDG.dll';

function QueryCardID(CardNum: LongInt; pDeviceID: PLongWord): LongWord; cdecl; external 'AIOWDG.dll';
function QueryCardName(CardNum: LongInt; pNameSize: pLongWord; pName: PAnsiChar): LongWord; cdecl; external 'AIOWDG.dll';
function QueryCardSerialNumber(CardNum: LongInt; var pSerialNumber: Int64): LongWord; cdecl; external 'AIOWDG.dll';
function QueryCardInfo(CardNum: LongInt; pDeviceID, pBase: PLongWord; pNameSize: pLongWord; pName: PAnsiChar): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_CloseCard(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_CloseAll: LongWord; cdecl; external 'AIOWDG.dll';

function WDG_SetTimeout(CardNum: LongInt; var pMilliseconds: Double): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_SetResetDuration(CardNum: LongInt; var pMilliseconds: Double): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_Pet(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_ReadTemp(CardNum: LongInt; out TempF: Double): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_ReadStatus(CardNum: LongInt; out StatusByte: LongWord): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_Start(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_Stop(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_HandleEvent(CardNum: LongInt; Action: LongWord): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_WaitForEvent(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_AbortEventRequest(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function WDG_EmergencyReboot(): LongWord; cdecl; external 'AIOWDG.dll';

function DI_ReadAll(CardNum: LongInt; pDIData: PByte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_Read1(CardNum: LongInt; BitIndex: Byte; pBitValue: PLongBool): LongWord; cdecl; external 'AIOWDG.dll';
function DI_ReadLatched(CardNum: LongInt; pDIRisen, pDIFallen: PByte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_PeekAll(CardNum: LongInt; pDIData: PByte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_Peek1(CardNum: LongInt; BitIndex: Byte; pBitValue: PLongBool): LongWord; cdecl; external 'AIOWDG.dll';
function DI_SetDebounceAll(CardNum: LongInt; TimeMS: Byte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_SetDebounce1(CardNum: LongInt; BitIndex: Byte; TimeMS: Byte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_SetDebounceSome(CardNum: LongInt; BitMask: Byte; TimeMS: Byte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_WaitForCOS(CardNum: LongInt; pDIData: PByte): LongWord; cdecl; external 'AIOWDG.dll';
function DI_WaitForCOSMulti(CardNum: LongInt; pTimestamp: PLongInt; DISize: LongInt; pDIData: PByte; pAIData: PDouble): LongWord; cdecl; external 'AIOWDG.dll';
function DI_AbortCOSRequest(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function DI_ReadTimestamp(CardNum: LongInt; pTimestamp: PWord): LongWord; cdecl; external 'AIOWDG.dll';

function DO_WriteAll(CardNum: LongInt; DOData: Byte): LongWord; cdecl; external 'AIOWDG.dll';
function DO_Write1(CardNum: LongInt; BitIndex: Byte; BitValue: LongBool): LongWord; cdecl; external 'AIOWDG.dll';
function DO_ReadbackAll(CardNum: LongInt; pDOData: PByte): LongWord; cdecl; external 'AIOWDG.dll';
function DO_SetPWM(CardNum: LongInt; BitIndex: LongWord; DutyCycle: Byte; RepCount: LongInt): LongWord; cdecl; external 'AIOWDG.dll';

function AI_Enable(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function AI_Disable(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';
function AI_ReadAll(CardNum: LongInt; pAIData: PDouble): LongWord; cdecl; external 'AIOWDG.dll';
function AI_Read1(CardNum: LongInt; ChannelIndex: Byte; pAIData: PDouble): LongWord; cdecl; external 'AIOWDG.dll';

function Speaker_SetFreq(CardNum: LongInt; Hz: LongInt): LongWord; cdecl; external 'AIOWDG.dll';

//Note that all error codes returned are Windows error codes; they can be found in winerror.h in the Windows SDK, or on the Web.




//These low-level functions are for future expansion and tech support use.
function CustomEEPROMRead(CardNum: LongInt; StartAddress: LongWord; var DataSize: LongWord; Data: Pointer): LongWord; cdecl; external 'AIOWDG.dll';
function CustomEEPROMWrite(CardNum: LongInt; StartAddress: LongWord; DataSize: LongWord; Data: Pointer): LongWord; cdecl; external 'AIOWDG.dll';
function GetCardByEEPROMByte(Data: Byte): LongInt; cdecl; external 'AIOWDG.dll';
function GetCardByEEPROMData(StartAddress, DataSize: LongWord; pData: PByte): LongInt; cdecl; external 'AIOWDG.dll';

function AIOWDG_GenericVendorRead(CardNum: LongInt; Request: Byte; Value, Index: Word; var DataSize: LongWord; pData: Pointer): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_GenericVendorWrite(CardNum: LongInt; Request: Byte; Value, Index: Word; DataSize: LongWord; pData: Pointer): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_GenericBulkIn(CardNum: LongInt; PipeID: LongWord; pData: Pointer; DataSize: LongWord; var BytesRead: LongWord): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_GenericBulkOut(CardNum: LongInt; PipeID: LongWord; pData: Pointer; DataSize: LongWord; var BytesWritten: LongWord): LongWord; cdecl; external 'AIOWDG.dll';
function AIOWDG_ResetChip(CardNum: LongInt): LongWord; cdecl; external 'AIOWDG.dll';

implementation

end.
